



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>爬虫-通过本地IP地址从中国天气网爬取当前城市天气情况</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">爬虫-通过本地IP地址从中国天气网爬取当前城市天气情况</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 17:19:46 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h4>1.问题描述</h4>
<p>​	最近在做一个pyqt登录校园网的小项目，想在窗口的状态栏加上当天的天气情况，用爬虫可以很好的解决我的问题。</br><br /><br />
*最新,发现www.ip.cn采用了js动态加载，所以代码有所变化，但整体思路不变</p>
<h4>2.解决思路</h4>
<p>​	考虑到所处位置的不同，需要先获取本地城市地址，然后作为中国天气网的输入，爬取指定城市的天气信息。</p>
<p>​	a. 先通过https://www.ip.cn/爬取本地城市名称</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302224351932-829348660.png"></p>
<p>b. 再通过获取本地城市名称作为输入</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302224737912-200601974.png"></p>
<p>进入城市页面获取所需信息即可，看起来不难，不就是爬、爬吗</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302224817350-247601171.png"></p>
<h4>3.思路实现</h4>
<p>​	a 很容易实现，直接上代码</p>
<pre class="prettyprint linenums"><code>def download_page(url):<br />
    &quot;&quot;&quot;<br />
    获取网页源代码<br />
    &quot;&quot;&quot;<br />
    headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0'}<br />
    html = requests.get(url, headers=headers)<br />
    # print(html.text)<br />
    return html.text

def get_city_name(html):<br />
    &quot;&quot;&quot;<br />
    对网页内容进行解析并分析得到需要的数据<br />
    &quot;&quot;&quot;<br />
    selector = etree.HTML(html)     # 将源码转换为能被XPath匹配的格式<br />
    _info = selector.xpath('//script')[1].text                   # 由于网页采用动态加载，“所在的地理位置”跑到了&lt;script&gt;中<br />
    location = re.findall(r&quot;&lt;code&gt;(.*?)&lt;/code&gt;&quot;, _info)[1]<br />
    location = location.split(&quot; &quot;)[0]<br />
    if location in municipality:<br />
        city = location[:-1]        # 直辖市的话不取'市'，不然天气结果会不准<br />
    else:<br />
        for i, char in enumerate(location):<br />
            if char == &quot;区&quot; or char == &quot;省&quot;:<br />
                index = i + 1<br />
                break<br />
        city = location[index:-1]       # 取'省'后面一直到'市'中间的城市名称用作天气搜索<br />
    return city<br />
</code></pre>
<p>我的ip会返回‘合肥’，北京，上海这些直辖市和一些自治区需要特别处理一下才能获得所需城市名，这里必须返回城市名称，不然直接搜索会出现这样，得不到任何天气data，好吧，能给我天气情况就行，要什么自行车：</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302225213838-396641465.png"></p>
<p>​</p>
<p>b 的话需要2步走，首先获取城市对于编码</p>
<p>在输入合肥点击搜索之后，通过观察网络请求信息，浏览器发送了一个GET请求，服务器响应数据中包含城市码，如下图<br /><br />
<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302223753048-1220978595.png"></p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302223758209-1781763570.png"></p>
<pre class="prettyprint linenums"><code>def get_city_code(city='合肥'):<br />
    &quot;&quot;&quot;<br />
    输入一个城市，返回在中国天气网上城市所对应的code<br />
    &quot;&quot;&quot;<br />
    try:<br />
        parameter = urlparse.parse.urlencode({'cityname': city})<br />
        conn = http.client.HTTPConnection('toy1.weather.com.cn', 80, timeout=5)<br />
        conn.request('GET', '/search?'+parameter)<br />
        r = conn.getresponse()<br />
        data = r.read().decode()[1:-1]<br />
        json_data = json.loads(data)<br />
        code = json_data[0]['ref'].split('~')[0]        # 返回城市编码<br />
        return code<br />
    except Exception as e:<br />
        raise e<br />
</code></pre>
<p>模拟发送请求即可，头信息在这，这里&amp;callback和&amp;_参数可以不要，然后对响应做下处理，因为得到的JSON数据字符串，需要将字符串转为JSON数据格式，这就能得到城市码了。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302225602251-1791716801.png"></p>
<p>终于到了最后一步，也是最烦，不对，是最难的一步，获取城市天气信息，按说操作思路和上面差不多，就是分析页面数据然后找标签就行了，，，</p>
<p>可是这个网站竟然是javascript动态加载的，获取的页面图上所指的内容啥都没，这要我怎么获取天气情况，对于只会爬取非动态网页的小白，只能留下没技术的眼泪。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302230558804-1507369337.png"></p>
<p>​就这样，又去学了一点动态爬取网站的基础知识，通过一个一个请求分析查看，终于找到了我所要的信息，其实只要看响应就行了，服务器js返回的值都在这能看到。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302230723179-947578542.png"></p>
<p>接着套路和上面一样，发送一个GET请求等服务器返回数据我们拿来用就行了</p>
<p>。。。。。。。。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302230321308-828433066.png"></p>
<p>问题又出现了，这次又是403，还有有人已经走过这条路了，在GET请求加上headers就行了，不让服务器发现这是爬虫，而是认为这是浏览器在请求，结果发现只需要在请求头加上Referer参数就行，看来服务器并没有真正做到反扒。。。。</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302230400409-1258259017.png"></p>
<pre class="prettyprint linenums"><code>def get_city_weather(city_code):<br />
    &quot;&quot;&quot;

    通过城市编码找到天气信息<br />
    &quot;&quot;&quot;<br />
    try:<br />
        url = 'http://www.weather.com.cn/weather1dn/' + city_code + '.shtml'<br />
        # 这里选择的体验新版，所以是1dn，旧版是1d<br />
        headers = { &quot;Referer&quot;: url }<br />
        conn = http.client.HTTPConnection('d1.weather.com.cn', 80, timeout=5)<br />
        conn.request('GET', '/sk_2d/' + city_code + '.html', headers=headers)<br />
        r = conn.getresponse()<br />
        data = r.read().decode()[13:]<br />
        weather_info = json.loads(data)<br />
        return weather_info<br />
    except Exception as e:<br />
        raise e<br />
</code></pre>
<p>好了，大功告成！</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1502909/201903/1502909-20190302223833174-1642502021.png"></p>
<p>贴一下自己的代码供有需要的人参考：</p>
<pre class="prettyprint linenums"><code># -*- coding:utf-8 -*-<br />
# 天气脚本<br />
import json<br />
import re<br />
import urllib as urlparse<br />
import http.client<br />
import requests<br />
from lxml import etree

target_url = 'https://www.ip.cn/'<br />
municipality = ['北京市','上海市','重庆市','天津市']

def download_page(url):<br />
    &quot;&quot;&quot;<br />
    获取网页源代码<br />
    &quot;&quot;&quot;<br />
    headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:66.0) Gecko/20100101 Firefox/66.0'}<br />
    html = requests.get(url, headers=headers)<br />
    # print(html.text)<br />
    return html.text

def get_city_name(html):<br />
    &quot;&quot;&quot;<br />
    对网页内容进行解析并分析得到需要的数据<br />
    &quot;&quot;&quot;<br />
    selector = etree.HTML(html)     # 将源码转换为能被XPath匹配的格式<br />
    _info = selector.xpath('//script')[1].text                   # 由于网页采用动态加载，“所在的地理位置”跑到了&lt;script&gt;中<br />
    location = re.findall(r&quot;&lt;code&gt;(.*?)&lt;/code&gt;&quot;, _info)[1]        #使用正则表达式获取地理位置信息，在&lt;code&gt;&lt;/code&gt;标签中<br />
    location = location.split(&quot; &quot;)[0]<br />
    if location in municipality:<br />
        city = location[:-1]        # 直辖市的话不取'市'，不然天气结果会不准<br />
    else:<br />
        for i, char in enumerate(location):<br />
            if char == &quot;区&quot; or char == &quot;省&quot;:<br />
                index = i + 1<br />
                break<br />
        city = location[index:-1]       # 取'省'后面一直到'市'中间的城市名称用作天气搜索<br />
    return city

def get_city_code(city='合肥'):<br />
    &quot;&quot;&quot;<br />
    输入一个城市，返回在中国天气网上城市所对应的code<br />
    &quot;&quot;&quot;<br />
    try:<br />
        parameter = urlparse.parse.urlencode({'cityname': city})<br />
        conn = http.client.HTTPConnection('toy1.weather.com.cn', 80, timeout=5)<br />
        conn.request('GET', '/search?' + parameter)<br />
        r = conn.getresponse()<br />
        data = r.read().decode()[1:-1]<br />
        json_data = json.loads(data)<br />
        code = json_data[0]['ref'].split('~')[0]        # 返回城市编码<br />
        return code<br />
    except Exception as e:<br />
        raise e

def get_city_weather(city_code):<br />
    &quot;&quot;&quot;<br />
    通过城市编码找到天气信息<br />
    &quot;&quot;&quot;<br />
    try:<br />
        url = 'http://www.weather.com.cn/weather1dn/' + city_code + '.shtml'<br />
        headers = { &quot;Referer&quot;: url }<br />
        conn = http.client.HTTPConnection('d1.weather.com.cn', 80, timeout=5)<br />
        conn.request('GET', '/sk_2d/' + city_code + '.html', headers=headers)<br />
        r = conn.getresponse()<br />
        data = r.read().decode()[13:]<br />
        weather_info = json.loads(data)<br />
        return weather_info<br />
    except Exception as e:<br />
        raise e

if __name__ == '__main__':<br />
    city = get_city_name(download_page(target_url))<br />
    city_code = get_city_code(city)<br />
    city_wether = get_city_weather(city_code)<br />
    print(city_wether)<br />
</code></pre>
<p>PS：第一次写博客，markdown刚学还不是很熟，表达可能也有点欠缺。</p>
<p>每次都是从别人那填好的坑走过，这次要填自己的坑，给别人开路</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq406n38.html">【转帖】四种BI 开源工具介绍-SpagoBI&comma;openI&comma;JasperSoft&comma;Pentaho</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xnglz8.html">文件I&sol;O之fcntl函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vl0pn8.html">Learning JavaScript Design Patterns The Observer Pattern</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mngjj6q.html">How debuggers work</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1meod9.html">web前端开发常用工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1rvjx8.html">Write operations are not allowed in read-only mode &lpar;FlushMode&period;MANUAL&rpar;&colon; Turn</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmnwg79.html">JS学习之闭包的理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1wr1mq.html">jQuery tablesort插件推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjj3lz8.html">Upgrade Ver 4&period;3&period;x from 4&period;2&period;x</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y622r8.html">房上的猫：for循环，跳转语句与循环结构，跳转语句进阶</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxpm38.html">iOS中判断照片和相机权限</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljrvlk9.html">&lbrack;区块链&bsol;理解BTCD源码&rsqb;GO语言实现一个区块链原型</a>
		</li>
						<li><a href="https://www.batexi.com/a/950or7v8.html">Vue&period;js实现后台菜单切换</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pxgd38.html">深入了解浏览器存储：对比Cookie、LocalStorage、sessionStorage与IndexedDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r7ml39.html">topcoder srm 575 div1</a>
		</li>
						<li><a href="https://www.batexi.com/a/960olev9.html">贴图平移&amp;amp&semi;凹凸贴图偏移</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnzp09.html">python win32com&period;client</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv40zy8.html">EF多字段求和（分组&sol;不分组）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv44ol8.html">python基础之Day7part2 史上最清晰字符编码理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e42krk9.html">poj 3177 Redundant Paths&lpar;边双连通分量&plus;缩点&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qnj7rog8.html">zabbix  主动模式和被动模式说名</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16gloq.html">ZABBIX监控mysql主从状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kemnz9.html">C&num; Json字符串保存信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y5xpw8.html">Nginx（三）------nginx 反向代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jrj2w8.html">OCR技术浅析-自写篇（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgon478.html">React Native之配置URL Scheme&lpar;iOS Android&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7z47de9.html">AngularJS 1&period;x系列：AngularJS简介及第一个应用（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zx4xn9.html">PhotoShop不用魔棒、钢笔 建立较平整的选区 P进电脑屏幕里</a>
			</li>
						<li><a href="https://www.batexi.com/a/96p17kn8.html">前端js区域上下拖拽</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1prl2q.html">HTML div 盒子 添加&sol;删除&mdash;&mdash;浮层</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
